/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *
 *  Copyright (C) 2005-2008 by TAKAGI Nobuhisa
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 */

/*!
 *  \file   toppers/debug.hpp
 *  \brief  fobOpCuɊւ錾`
 */
#ifndef TOPPERS_DEBUG_HPP_
#define TOPPERS_DEBUG_HPP_

#include "toppers/config.hpp"
#include <iostream>
#if defined( _WIN32 ) || defined( __WIN32__ ) || defined( WIN32 )
#include <windows.h>
#include <sstream>
#endif

namespace toppers
{

  template < typename T >
  void trace( char const* str, const T& value )
  {
#if defined( _WIN32 ) || defined( __WIN32__ ) || defined( WIN32 )
    std::ostringstream ostr;
    ostr << str << value << '\n';
    ::OutputDebugString( ostr.str().c_str() );
#else
    std::cerr << str << value << std::endl;
#endif
  }

}

#if defined( _DEBUG ) || defined( __DEBUG ) || defined( DEBUG )
#define TOPPERS_TRACE( str, value )   ::toppers::trace( ( str ), ( value ) )
#else
#define TOPPERS_TRACE( str, value )   ( ( void )0 )
#endif

#endif  // ! TOPPERS_DEBUG_HPP_
